洛谷 P1595 信封问题 C语言dp

题目描述

某人写了 n 封信和 n 个信封,如果所有的信都装错了信封。求所有信都装错信封共有多少种不同情况。

输入格式

一个信封数 n,保证 n≤20。

输出格式

一个整数,代表有多少种情况。

输入输出样例

输入 #1

2

输出 #1

1

输入 #2

3

输出 #2

2

说明/提示

对于 100% 的数据,1≤n≤20。

思路:

我们假设一个数组dp27,我们需要推出有n个信封的时候排错的可能,举例,首先第i个信封放在了k位置上,分为两种情况。

  • 情况一 :原本应该放在位置 k 上的信封也恰好被放置在了位置 i 上。因此,这种情况下剩下的 n-2 个信封需要全部错排,即 dp[i-2] 种方式。
  • 情况二 :原本应该放在位置 k 上的信封不在位置 i 上。所以剩下的 i-1 个信封的错排数实际上是 dp[i-1]。
  • 由于这两种情况是互斥的(即它们不能同时发生),所以我们将它们的结果相加,并乘以 (i-1)(因为我们有 i-1 种方式将第 i 个信封放置到其他位置上),从而得到递推关系:dp[i] = (i-1) * (dp[i-1] + dp[i-2])。

代码如下:

复制代码
#include<iostream>
using namespace std;
typedef long long ll;
ll dp[27]; 
int main()
{
	ll n;
	cin >> n;
	dp[0] = 1;
	dp[1] = 0;
	for(ll i = 2 ; i <= n ; i++)
	{
		dp[i] = (i-1)*(dp[i-1]+dp[i-2]);
	}
	cout << dp[n];
	return 0;
}
相关推荐
NEFU_Jyj1 小时前
牛客周赛R168
算法
Navigator_Z9 小时前
LeetCode //C - 1317. Convert Integer to the Sum of Two No-Zero Integers
c语言·算法·leetcode
D e re k ZH10 小时前
C++ 标准库算法全景指南
数据结构·c++·算法
冻柠檬飞冰走茶10 小时前
字母移动游戏题解:贪心求最长可保留连续子串(附 C 实现)
c语言·开发语言·数据结构·算法·动态规划
雪落漂泊11 小时前
C++算法 二分查找篇(上)
开发语言·c++·算法
LabVIEW开发12 小时前
LabVIEW 连接板:28 个端子怎么排,优先级怎么定
java·算法·labview
严肃小白兔14 小时前
MATLAB 数值计算中的精度与误差问题:浮点运算、误差传播与数值稳定性
人工智能·算法·matlab
青少儿编程课堂15 小时前
蓝桥杯青少组图形化省考报名倒计时·全国青少年信息素养大赛·电子学会图形化考级:校园黑白棋人机对战解析
c++·python·算法·bfs·信息学竞赛
jktantan16 小时前
注解式脱敏:用 Jackson 的 ContextualSerializer 做字段级策略(一)
spring boot·后端·算法·spring cloud·系统架构